function varargout = rainSTORM(varargin)
% RAINSTORM MATLAB code for rainSTORM.fig
%      RAINSTORM, by itself, creates a new RAINSTORM or raises the existing
%      singleton*.
%
%      H = RAINSTORM returns the handle to a new RAINSTORM or the handle to
%      the existing singleton*.
%
%      RAINSTORM('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in RAINSTORM.M with the given input arguments.
%
%      RAINSTORM('Property','Value',...) creates a new RAINSTORM or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before rainSTORM_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to rainSTORM_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help rainSTORM

% Last Modified by GUIDE v2.5 20-Apr-2016 12:49:49

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @rainSTORM_OpeningFcn, ...
    'gui_OutputFcn',  @rainSTORM_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before rainSTORM is made visible.
function rainSTORM_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to rainSTORM (see VARARGIN)

% Choose default command line output for rainSTORM
handles.output = hObject;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% If there is no input structure, then the GUI uses the default.
if ~isempty(varargin)
    params=varargin{1};
else
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Create Params Struct with default parameter settings.
    params = rainSTORM_default_struct_params;
end
handles.params=params;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Read back last image dir.
global rainSTORM_env
last_image_dir_filename = [rainSTORM_env.rainSTORM_dir,filesep,'utils',filesep,'last_image_dir.txt'];
if exist(last_image_dir_filename, 'file')
    handles.last_image_dir = fileread(last_image_dir_filename);
else
    handles.last_image_dir = pwd;
end


for idx_ch = 2:length(params.ch_data)
    handles.Channel_Settings_Radiobutton_h(idx_ch) = Add_channel_radio_button(hObject, eventdata, handles);
end
handles.params=params;

set(handles.Raw_Image_Filename,'String',params.ch_data{1}.rawdata_mgr.fullfilename);

set_Algo_Settings_panel(hObject, eventdata, handles);
set_Channel_Settings_Panel(hObject, eventdata, handles);

handles.flagSum = 1;
set(handles.Display_Sum_Image,'Value',handles.flagSum);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes rainSTORM wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = rainSTORM_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function Raw_Image_Filename_Callback(hObject, eventdata, handles)
% hObject    handle to Raw_Image_Filename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Raw_Image_Filename as text
%        str2double(get(hObject,'String')) returns contents of Raw_Image_Filename as a double

fullfilename = get(hObject,'String');
if ~exist(fullfilename, 'file')
    set(handles.Select_Calibration_File,'String','File does not exist!!!');
    pause(1)
    set(handles.Select_Calibration_File,'String','');
    return;
end

selected_channel = get_selected_channel(hObject, eventdata, handles);
handles.params.ch_data{selected_channel,1}.rawdata_mgr.fullfilename = fullfilename;
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function Raw_Image_Filename_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Raw_Image_Filename (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in Select_Image_Button.
function Select_Image_Button_Callback(hObject, eventdata, handles)
% hObject    handle to Select_Image_Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global rainSTORM_env
selected_channel = get_selected_channel(hObject, eventdata, handles);
[FileName,PathName]=uigetfile(...
    {'*.tif; *.raw; *.nd2; *.dat' 'Image files (*.tif,*.raw,*.nd2,*.dat)';...
    '*.full.csv' 'Previous report (*.full.csv)';...
    '*.*' 'All files (*.*)'},...
    'Select a file',rainSTORM_env.last_image_dir);
if ~isequal(FileName, 0) && ~isequal(PathName, 0)
    fullfilename = fullfile(PathName,FileName);
    set(handles.Raw_Image_Filename,'String',fullfilename,'TooltipString',fullfilename);
    handles.params.ch_data{selected_channel,1}.rawdata_mgr.fullfilename = fullfilename;
    assignin('base','params',handles.params);
    
    rainSTORM_env.last_image_dir = PathName;
    fileID = fopen([rainSTORM_env.rainSTORM_dir,filesep,'GUI',filesep,'last_image_dir.txt'],'w');
    fprintf(fileID,'%s\n',PathName);
    fclose(fileID);
end
guidata(hObject, handles);


% --- Executes on selection change in Select_Read_Method.
function Select_Read_Method_Callback(hObject, eventdata, handles)
% hObject    handle to Select_Read_Method (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Select_Read_Method contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Select_Read_Method

selected_channel = get_selected_channel(hObject, eventdata, handles);
handles.params.ch_data{selected_channel,1}.rawdata_mgr.readmethod = ...
    handles.available_read_methods{get(hObject,'Value')};
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Select_Read_Method_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Select_Read_Method (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

raw_stack_params = rainSTORM_read_stack;
handles.available_read_methods = raw_stack_params.available_readmethods;
set(hObject,'String',handles.available_read_methods);
guidata(hObject, handles);

% --- Executes on selection change in Select_Image_Processing_Algo.
function Select_Image_Processing_Algo_Callback(hObject, eventdata, handles)
% hObject    handle to Select_Image_Processing_Algo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns Select_Image_Processing_Algo contents as cell array
%        contents{get(hObject,'Value')} returns selected item from Select_Image_Processing_Algo

selected_channel = get_selected_channel(hObject, eventdata, handles);
algo_name = handles.algo_names_and_handles_loc.names{get(hObject,'Value')};
handles.params.ch_data{selected_channel,1}.localization.algo_name = algo_name;
handles.params.ch_data{selected_channel,1}.localization.settings = rainSTORM_default_settings_loc_algos(algo_name);
set_Algo_Settings_panel(hObject, eventdata, handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Select_Image_Processing_Algo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Select_Image_Processing_Algo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
handles.algo_names_and_handles_loc = rainSTORM_default_settings_loc_algos;
set(hObject,'String',handles.algo_names_and_handles_loc.names);
guidata(hObject, handles);


function Select_Calibration_File_Callback(hObject, eventdata, handles)
% hObject    handle to Select_Calibration_File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Select_Calibration_File as text
%        str2double(get(hObject,'String')) returns contents of Select_Calibration_File as a double

fullfilename = get(hObject,'String');
if ~exist(fullfilename, 'file')
    set(handles.Select_Calibration_File,'String','File does not exist!!!');
    pause(1)
    set(handles.Select_Calibration_File,'String','');
    return;
end

selected_channel = get_selected_channel(hObject, eventdata, handles);
handles.params.ch_data{selected_channel,1}.optoff_info.fullfilename = fullfilename;
load_struct = load(fullfilename,'optoff');
handles.params.ch_data{selected_channel,1}.optoff_info.optoff = load_struct.optoff;
set(handles.popupmenu_Optical_Offset_Calibration,'String',[{handles.params.ch_data{selected_channel,1}.optoff_info.optoff.Name}';'None'])
handles.params.ch_data{selected_channel,1}.optoff_info.selected = get(handles.popupmenu_Optical_Offset_Calibration,'Value');

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Select_Calibration_File_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Select_Calibration_File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in popupmenu_Optical_Offset_Calibration.
function popupmenu_Optical_Offset_Calibration_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_Optical_Offset_Calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
handles.params.ch_data{selected_channel,1}.optoff_info.selected = get(hObject,'Value');
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function popupmenu_Optical_Offset_Calibration_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_Optical_Offset_Calibration (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbutton_Select_Calibration_File.
function pushbutton_Select_Calibration_File_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Select_Calibration_File (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global rainSTORM_env
selected_channel = get_selected_channel(hObject, eventdata, handles);
[FileName,PathName]=uigetfile(...
    {'*.mat' 'Matlab files (*.mat)';...
    '*.*' 'All files (*.*)'},...
    'Select a file',rainSTORM_env.calibration_tool_def_dir);
if ~isequal(FileName, 0) && ~isequal(PathName, 0)
    fullfilename = fullfile(PathName,FileName);
    set(handles.Select_Calibration_File,'String',fullfilename,'TooltipString',fullfilename);
    handles.params.ch_data{selected_channel,1}.optoff_info.fullfilename = fullfilename;
    load_struct = load(fullfilename,'optoff');
    handles.params.ch_data{selected_channel,1}.optoff_info.optoff = load_struct.optoff;
    set(handles.popupmenu_Optical_Offset_Calibration,'String',[{handles.params.ch_data{selected_channel,1}.optoff_info.optoff.Name}';'None'])
    handles.params.ch_data{selected_channel,1}.optoff_info.selected = get(handles.popupmenu_Optical_Offset_Calibration,'Value');
end

guidata(hObject, handles);


% --- Executes on button press in Display_Sum_Image.
function Display_Sum_Image_Callback(hObject, eventdata, handles)
% hObject    handle to Display_Sum_Image (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Display_Sum_Image

handles.flagSum = get(hObject,'Value');
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Algo_Settings_Panel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Algo_Settings_Panel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

handles.Algo_Settings_slider = uicontrol('Style','Slider','Parent',hObject,...
    'Units','normalized','Position',[0.95 0 0.05 1],...
    'Visible','on',...
    'BackgroundColor',[0.8 0.8 0.8],...
    'Value',1);

guidata(hObject, handles);


function slider_callback1(hObject, eventdata, handles, panel_first_line_pos, panel_max_lines, panel_line_space)

val = get(hObject,'Value');

num_of_params = length(handles.Algo_Settings_handles);
for idx_setting = 1:num_of_params
    for idx_component = 1:length(handles.Algo_Settings_handles(idx_setting).h)
        h = handles.Algo_Settings_handles(idx_setting).h(idx_component);
        pos = get(h,'Position');
        pos_new = panel_first_line_pos - idx_setting * panel_line_space + (num_of_params-panel_max_lines - val) * panel_line_space;
        pos(2) = pos_new;
        if (pos_new < panel_first_line_pos - panel_max_lines * panel_line_space) || (pos_new > panel_first_line_pos - panel_line_space)
            visibility='off';
        else
            visibility='on';
        end
        set(h,...
            'Position',pos,...
            'Visible',visibility);
    end
end

guidata(hObject, handles);

function set_Algo_Settings_value(hObject, eventdata, algo_param_name, idx, type, style)

switch style
    case 'popup'
        contents = get(hObject,'String'); 
        data_to_write = contents{get(hObject,'Value')};
    otherwise
        data_to_write = get(hObject,'String');
end

switch type
    case 'number'
        data_to_write = str2double(data_to_write);
end

handles = guidata(gcbo);
selected_channel = get_selected_channel(hObject, eventdata, handles);

switch style
    case 'popup'
        handles.params.ch_data{selected_channel}.localization.settings.(algo_param_name{1}).val = data_to_write;
    otherwise
        handles.params.ch_data{selected_channel}.localization.settings.(algo_param_name{1}).val(idx) = data_to_write;
end        

guidata(hObject, handles);


function set_Channel_Settings_Panel(hObject, eventdata, handles)

selected_channel = get_selected_channel(hObject, eventdata, handles);

set(handles.Channel_name,'String',handles.params.ch_data{selected_channel,1}.channel_name);
set(handles.Raw_Image_Filename,...
    'String',handles.params.ch_data{selected_channel,1}.rawdata_mgr.fullfilename,...
    'TooltipString',handles.params.ch_data{selected_channel,1}.rawdata_mgr.fullfilename);

method_match = strfind(handles.available_read_methods,...
    handles.params.ch_data{selected_channel,1}.rawdata_mgr.readmethod);
match = 0;
for idx_meth=1:length(method_match)
    if method_match{idx_meth} == 1
        match = 1;
        break
    end
end
if match == 0
    error(['Uknown readmethod in channel ', num2str(selected_channel)])
else
    set(handles.Select_Read_Method,'Value',idx_meth);
end

set(handles.Select_Image_Processing_Algo,'Value',...
    find(strcmp(handles.algo_names_and_handles_loc.names,handles.params.ch_data{selected_channel,1}.localization.algo_name)==1)...
    );

guidata(hObject, handles);


function set_Optical_Offset_Calibration_Panel(hObject, eventdata, handles)

selected_channel = get_selected_channel(hObject, eventdata, handles);

if isfield(handles.params.ch_data{selected_channel,1},'optoff_info')
    fullfilename = handles.params.ch_data{selected_channel,1}.optoff_info.fullfilename;
    set(handles.Select_Calibration_File,'String',fullfilename,'TooltipString',fullfilename);
    set(handles.popupmenu_Optical_Offset_Calibration,...
        'String',[{handles.params.ch_data{selected_channel,1}.optoff_info.optoff.Name}';'None'],...
        'Value',handles.params.ch_data{selected_channel,1}.optoff_info.selected);
else
    set(handles.Select_Calibration_File,'String',' ','TooltipString','Calibration file is not specified.');
    set(handles.popupmenu_Optical_Offset_Calibration,...
        'String','None',...
        'Value',1);
end


function set_Algo_Settings_panel(hObject, eventdata, handles)

% Clean up
h = get(handles.Algo_Settings_Panel,'Children');
h(h == handles.Algo_Settings_slider) = [];
delete(h);

handles.Algo_Settings_handles=[];

selected_channel = get_selected_channel(hObject, eventdata, handles);
algo_gui_params = handles.params.ch_data{selected_channel}.localization.settings;

panel_pos = get(handles.Algo_Settings_Panel,'Position');
panel_unit = get(handles.Algo_Settings_Panel,'Unit');

panel_line_space = 30;
panel_first_line_pos = panel_pos(4)-panel_line_space/2;
panel_max_lines = floor(panel_pos(4) / panel_line_space)-1;
algo_param_names = fieldnames(algo_gui_params);
num_of_params = length(algo_param_names);

for idx_param = 1:num_of_params
    if idx_param > panel_max_lines
        visibility='off';
    else
        visibility='on';
    end
    % descriptions
    handles.Algo_Settings_handles(idx_param).h(1) = uicontrol(...
        handles.Algo_Settings_Panel,...
        'Style','text',...
        'String',algo_gui_params.(algo_param_names{idx_param}).text,...
        'HorizontalAlignment','left',...
        'BackgroundColor',[0.8 0.8 0.8],...
        'TooltipString',algo_gui_params.(algo_param_names{idx_param}).tooltip,...
        'Units',panel_unit,...
        'Visible',visibility,...
        'Position', [10 panel_first_line_pos-idx_param*panel_line_space panel_pos(3)-150 20]);
    
    % input uicontrols
    
    if ~isfield( algo_gui_params.(algo_param_names{idx_param}), 'style' )
        algo_gui_params.(algo_param_names{idx_param}).style = 'edit';
    end
    
    
    switch algo_gui_params.(algo_param_names{idx_param}).style
        case 'popup'
            nInputs = 1;
        otherwise
            nInputs = length(algo_gui_params.(algo_param_names{idx_param}).val);
    end
    
    for i = 1:nInputs
        switch algo_gui_params.(algo_param_names{idx_param}).style
            case 'popup'
                string = algo_gui_params.(algo_param_names{idx_param}).string;
                for ix = 1:length(string)
                    if strcmp( string{ix}, algo_gui_params.(algo_param_names{idx_param}).val )
                        val = ix;
                        break
                    end
                end
                position =  [panel_pos(3)-140  panel_first_line_pos-idx_param*panel_line_space 110 20];
            otherwise
                string = algo_gui_params.(algo_param_names{idx_param}).val(i);
                val = 1;
                position =  [panel_pos(3)-80-(nInputs-i)*60  panel_first_line_pos-idx_param*panel_line_space 50 20];
        end
        handles.Algo_Settings_handles(idx_param).h(1+i) = uicontrol(...
            handles.Algo_Settings_Panel,...
            'Callback',{@set_Algo_Settings_value, algo_param_names(idx_param), i, algo_gui_params.(algo_param_names{idx_param}).type, algo_gui_params.(algo_param_names{idx_param}).style},...
            'Style', algo_gui_params.(algo_param_names{idx_param}).style,...
            'String',string,...
            'Value', val,...
            'HorizontalAlignment','center',...
            'Units',panel_unit,...
            'Visible',visibility,...
            'Position', position);
    end
        
%     if length(algo_gui_params.(algo_param_names{idx_param}).val) == 1
%         handles.Algo_Settings_handles(idx_param).h(2) = uicontrol(...
%             handles.Algo_Settings_Panel,...
%             'Callback',{@set_Algo_Settings_value, algo_param_names(idx_param), 1, algo_gui_params.(algo_param_names{idx_param}).type},...
%             'Style','edit',...
%             'String',num2str(algo_gui_params.(algo_param_names{idx_param}).val),...
%             'HorizontalAlignment','center',...
%             'Units',panel_unit,...
%             'Visible',visibility,...
%             'Position', [panel_pos(3)-80  panel_first_line_pos-idx_param*panel_line_space 50 20]);
%     else
%         handles.Algo_Settings_handles(idx_param).h(2) = uicontrol(...
%             handles.Algo_Settings_Panel,...
%             'Callback',{@set_Algo_Settings_value, algo_param_names(idx_param), 1, algo_gui_params.(algo_param_names{idx_param}).type},...
%             'Style','edit',...
%             'String',num2str(algo_gui_params.(algo_param_names{idx_param}).val(1)),...
%             'HorizontalAlignment','center',...
%             'Units',panel_unit,...
%             'Visible',visibility,...
%             'Position', [panel_pos(3)-140  panel_first_line_pos-idx_param*panel_line_space 50 20]);
%         handles.Algo_Settings_handles(idx_param).h(3) = uicontrol(...
%             handles.Algo_Settings_Panel,...
%             'Callback',{@set_Algo_Settings_value, algo_param_names(idx_param), 2, algo_gui_params.(algo_param_names{idx_param}).type},...
%             'Style','edit',...
%             'String',num2str(algo_gui_params.(algo_param_names{idx_param}).val(end)),...
%             'HorizontalAlignment','center',...
%             'Units',panel_unit,...
%             'Visible',visibility,...
%             'Position', [panel_pos(3)-80  panel_first_line_pos-idx_param*panel_line_space 50 20]);
%     end
end

if num_of_params<=panel_max_lines
    set(handles.Algo_Settings_slider,...
        'Visible','off');
else
    set(handles.Algo_Settings_slider,...
        'Visible','on',...
        'Min',0,'Max',(num_of_params-panel_max_lines),...
        'Value',(num_of_params-panel_max_lines),...
        'Callback',{@slider_callback1, handles, panel_first_line_pos, panel_max_lines, panel_line_space},...
        'SliderStep',[1 1]./(num_of_params-panel_max_lines));
end

guidata(hObject, handles);

% --- Executes on button press in Ch1.
function Ch1_Callback(hObject, eventdata, handles)
% hObject    handle to Ch1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in Add_channel.
function h = Add_channel_radio_button(hObject, eventdata, handles)
% hObject    handle to Add_channel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

num_of_channels = length(handles.Channel_Settings_Radiobutton_h);
if num_of_channels<7
    panel_pos = get(handles.Channel_Select_Button_Group,'Position');
    panel_unit = get(handles.Channel_Select_Button_Group,'Unit');
    h = uicontrol(...
        handles.Channel_Select_Button_Group,...
        'BackgroundColor',[0.8 0.8 0.8],...
        'Style','radiobutton',...
        'String',['Ch ', num2str(num_of_channels+1)],...
        'HorizontalAlignment','left',...
        'Units',panel_unit,...
        'Position', [20 panel_pos(4)-45-num_of_channels*30 50 20]);
end


% --- Executes on button press in Add_channel_button.
function Add_channel_button_Callback(hObject, eventdata, handles)
% hObject    handle to Add_channel_button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

num_of_channels = length(handles.Channel_Settings_Radiobutton_h);
selected_channel = get_selected_channel(hObject, eventdata, handles);

if num_of_channels<7
    handles.Channel_Settings_Radiobutton_h(num_of_channels+1) =...
        Add_channel_radio_button(hObject, eventdata, handles);
    handles.params.ch_data{end+1,1} = handles.params.ch_data{selected_channel,1};
    guidata(hObject, handles);
end

function Channel_name_Callback(hObject, eventdata, handles)
% hObject    handle to Channel_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Channel_name as text
%        str2double(get(hObject,'String')) returns contents of Channel_name as a double

selected_channel = get_selected_channel(hObject, eventdata, handles);
handles.params.ch_data{selected_channel,1}.channel_name = get(hObject,'String');
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function Channel_name_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Channel_name (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in Remove_Channel_Button.
function Remove_Channel_Button_Callback(hObject, eventdata, handles)
% hObject    handle to Remove_Channel_Button (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if length(handles.Channel_Settings_Radiobutton_h)>1
    
    selected_channel = get_selected_channel(hObject, eventdata, handles);
    
    if get(handles.Channel_Settings_Radiobutton_h(selected_channel),'Value')==1
        if selected_channel>1
            set(handles.Channel_Settings_Radiobutton_h(selected_channel-1),'Value',1);
        else
            set(handles.Channel_Settings_Radiobutton_h(2),'Value',1);
        end
    end
    try
        delete(handles.Channel_Settings_Radiobutton_h(selected_channel));
    catch
    end
    handles.Channel_Settings_Radiobutton_h(selected_channel)=[];
    handles.params.ch_data = handles.params.ch_data([1:(selected_channel-1) (selected_channel+1:end)]);
    
    rearrange_radiobuttons(hObject, eventdata, handles);
    Channel_Select_Button_Group_SelectionChangeFcn(hObject, eventdata, handles);
    
    guidata(hObject, handles);
end


% --- Executes during object creation, after setting all properties.
function Channel_Select_Button_Group_CreateFcn(hObject, eventdata, handles)
% hObject    handle to Channel_Select_Button_Group (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

set(hObject,'Units','pixels');
panel_pos= get(hObject,'Position');

handles.Channel_Settings_Radiobutton_h=uicontrol(...
    hObject,...
    'BackgroundColor',[0.8 0.8 0.8],...
    'Style','radiobutton',...
    'String','Ch 1',...
    'HorizontalAlignment','left',...
    'Units','pixels',...
    'Position', [20 panel_pos(4)-45 50 20]);

guidata(hObject, handles);


% --- Executes on button press in Process_All_Channels.
function Process_All_Channels_Callback(hObject, eventdata, handles)
% hObject    handle to Process_All_Channels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

for selected_channel = 1:length(handles.params.ch_data)
    handles.params.ch_data{selected_channel,1} = rainSTORM_main(handles.params.ch_data{selected_channel,1});
    % Find sum of fluorescence images if desired.
    if isfield(handles, 'flagSum') && handles.flagSum
        sumFrame = handles.params.ch_data{selected_channel,1}.localization.results.sumFrame;
        prevSF = handles.params.ch_data{selected_channel,1}.localization.settings.prevSF.val;
        figure('Name',['Sum Image, channel name: ', handles.params.ch_data{selected_channel,1}.channel_name]);
        % Scale Sum image display to match preview reconstruction.
        imshow(sumFrame,'border','tight','InitialMagnification',prevSF*100)
        caxis([min(sumFrame(:)) max(sumFrame(:))]);
        colormap(gray)
        drawnow
    end
end

guidata(hObject, handles);


% --- Executes on button press in Process_Current_Channel.
function Process_Current_Channel_Callback(hObject, eventdata, handles)
% hObject    handle to Process_Current_Channel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selected_channel = get_selected_channel(hObject, eventdata, handles);
handles.params.ch_data{selected_channel,1} = rainSTORM_main(handles.params.ch_data{selected_channel,1});

if handles.flagSum
    sumFrame = handles.params.ch_data{selected_channel,1}.localization.results.sumFrame;
    prevSF = handles.params.ch_data{selected_channel,1}.localization.settings.prevSF.val;
    figure('Name',['Sum Image, channel name: ', handles.params.ch_data{selected_channel,1}.channel_name]);
    % Scale Sum image display to match preview reconstruction.
    imshow(sumFrame,'border','tight','InitialMagnification',prevSF*100)
    caxis([min(sumFrame(:)) max(sumFrame(:))]);
    colormap(gray)
end
guidata(hObject, handles);


% --- Executes on button press in Save.
function Save_Callback(hObject, eventdata, handles)
% hObject    handle to Save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uiputfile(...
    {'*.mat'},...
    'Select file to Save Processed Data',...
    handles.last_image_dir);
if ~isequal(FileName, 0) && ~isequal(PathName, 0)
    filename = fullfile(PathName,FileName);
    params = handles.params;
    save(filename, 'params');
end


% --- Executes on button press in Reviewer_open.
function Reviewer_open_Callback(hObject, eventdata, handles)
% hObject    handle to Reviewer_open (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

for selected_channel = 1:length(handles.params.ch_data)
    if ~isempty(handles.params.ch_data{selected_channel, 1}.localization.results.SupResParams)
        continue;
    end
    handles.params.ch_data{selected_channel,1} = rainSTORM_main(handles.params.ch_data{selected_channel,1});
%     % Find sum of fluorescence images if desired.
%     if handles.flagSum
%         sumFrame = handles.params.ch_data{selected_channel,1}.localization.results.sumFrame;
%         prevSF = handles.params.ch_data{selected_channel,1}.localization.settings.prevSF.val;
%         figure('Name',['Sum Image, channel name: ', handles.params.ch_data{selected_channel,1}.channel_name]);
%         % Scale Sum image display to match preview reconstruction.
%         imshow(sumFrame,'border','tight','InitialMagnification',prevSF*100)
%         caxis([min(sumFrame(:)) max(sumFrame(:))]);
%         colormap(gray)
%         drawnow
%     end
end

guidata(hObject, handles);

rainSTORM_Image_Viewer(handles.params);


% --- Executes when selected object is changed in Channel_Select_Button_Group.
function Channel_Select_Button_Group_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in Channel_Select_Button_Group
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)

% selected_channel = get_selected_channel(hObject, eventdata, handles);
% disp(['Selected Channel: ',num2str(selected_channel)]);

set_Algo_Settings_panel(hObject, eventdata, handles);
set_Channel_Settings_Panel(hObject, eventdata, handles);
set_Optical_Offset_Calibration_Panel(hObject, eventdata, handles);

guidata(hObject, handles);


function selected_channel = get_selected_channel(hObject, eventdata, handles)

if ~isfield(handles,'Channel_Settings_Radiobutton_h')
    selected_channel=0;
    return
end
for selected_channel=1:length(handles.Channel_Settings_Radiobutton_h)
    if get(handles.Channel_Settings_Radiobutton_h(selected_channel),'Value')==1
        break
    end
end


function rearrange_radiobuttons(hObject, eventdata, handles)

num_of_channels=length(handles.Channel_Settings_Radiobutton_h);
panel_pos = get(handles.Channel_Select_Button_Group,'Position');
panel_unit = get(handles.Channel_Select_Button_Group,'Unit');
for idx_radiobutton=1:num_of_channels
    set(handles.Channel_Settings_Radiobutton_h(idx_radiobutton),...
        'Position', [20 panel_pos(4)-45-(idx_radiobutton-1)*30 50 20],...
        'String',['Ch ', num2str(idx_radiobutton)]);
end

guidata(hObject, handles);


% --- Executes on button press in LoadButton.
function LoadButton_Callback(hObject, eventdata, handles)
% hObject    handle to LoadButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[FileName,PathName] = uigetfile(...
    {'*.mat'},...
    'Select file to Load Processed Data',...
    handles.last_image_dir);
if ~isequal(FileName, 0) && ~isequal(PathName, 0)
    filename = fullfile(PathName,FileName);
    load(filename, 'params');
    handles.params = params;
end
guidata(hObject, handles);

