function ch_data=rainSTORM_main(ch_data)

global rainSTORM_env
global rainSTORM_raw_stack

   
algo_name = ch_data.localization.algo_name;
settings = ch_data.localization.settings;

algo_names_and_handles = rainSTORM_default_settings_loc_algos;
algo_handle = algo_names_and_handles.fhandle{...
    strcmp(algo_names_and_handles.names,algo_name)==1};

tic
raw_stack_params = rainSTORM_read_stack(ch_data.rawdata_mgr,rainSTORM_env.is_tifflib_avail);
sizeOfCCDFrame = raw_stack_params.getFrameSize();
numberOfFrames = raw_stack_params.getNumberOfImages();

% Localization?  Or importing previous? That is the question!
% --by William STORMSphere - 2016-04-22
if (strfind(ch_data.rawdata_mgr.readmethod,'csv'))
    SupResParams = [];
    ReadInTable = table2struct(rainSTORM_raw_stack,'ToScalar',true);
    for tableIndex = 1:size(ReadInTable.frame_idx)
    SupResParams(tableIndex).frame_idx = ReadInTable.frame_idx(tableIndex)';
    SupResParams(tableIndex).x_coord = ReadInTable.x_coord(tableIndex)';
    SupResParams(tableIndex).y_coord = ReadInTable.y_coord(tableIndex)';
    SupResParams(tableIndex).z_coord = ReadInTable.z_coord(tableIndex)';
    SupResParams(tableIndex).I = ReadInTable.I(tableIndex)';
    SupResParams(tableIndex).sig_x = ReadInTable.sig_x(tableIndex)';
    SupResParams(tableIndex).sig_y = ReadInTable.sig_y(tableIndex)';
    SupResParams(tableIndex).avg_brightness = ReadInTable.avg_brightness(tableIndex)';
    SupResParams(tableIndex).res = ReadInTable.res(tableIndex)';
    SupResParams(tableIndex).res_Row = ReadInTable.res_Row(tableIndex)';
    SupResParams(tableIndex).res_Col = ReadInTable.res_Col(tableIndex)';
    SupResParams(tableIndex).roi_min = ReadInTable.roi_min(tableIndex)';
    SupResParams(tableIndex).Sum_signal = ReadInTable.Sum_signal(tableIndex)';
end
% Store results in channel data struct
    ch_data.localization.results.sumFrame = zeros(sizeOfCCDFrame);
    disp('Imported...')
else
% Do the normal thing, just localize.

SupResParams = [];

clear parfor_progress_2
rainSTORM_parfor_progress(numberOfFrames);
if rainSTORM_env.parCompTool
    parfor lpIm=1:numberOfFrames
        frame_to_process=rainSTORM_raw_stack(:,:,lpIm);
        SRP = rainSTORM_main_loop(lpIm,frame_to_process,algo_handle,settings);
        SupResParams = [SupResParams, SRP];
        rainSTORM_parfor_progress;
    end
else
    for lpIm=1:numberOfFrames;
        frame_to_process=rainSTORM_raw_stack(:,:,lpIm);
        SRP = rainSTORM_main_loop(lpIm, frame_to_process,algo_handle,settings);
        SupResParams = [SupResParams, SRP];
        rainSTORM_parfor_progress;
    end
end
rainSTORM_parfor_progress(0);
toc

% Do offset correction if it is specified.
if isfield(ch_data, 'optoff_info') && ~isempty(ch_data.optoff_info)
    if ch_data.optoff_info.selected <= length(ch_data.optoff_info.optoff)
        settings_optoff.TFORM = ch_data.optoff_info.optoff(ch_data.optoff_info.selected).TFORM;
        SupResParams = rainSTORM_unOffset(SupResParams,settings_optoff);
        disp('Offset Correction was applied.')
    end
end

% Store results in channel data struct
ch_data.localization.results.sumFrame = uint32(sum(rainSTORM_raw_stack,3));

end  % This is the end for William STORMSphere's mess


ch_data.localization.results.SupResParams = SupResParams;
ch_data.localization.results.numberOfFrames = numberOfFrames; % (Means number of frames)
ch_data.localization.results.numberOfLocs = length(SupResParams);
ch_data.rawdata_mgr.myImInfo.sizeOfCCDFrame = sizeOfCCDFrame; % Size of CCD image

% Store the raw CCD parameters for super resolved image reconstruction.
ch_data.reviewer{1,1}.settings.recon_algo_settings.sizeOfCCDFrame.val = sizeOfCCDFrame;
ch_data.reviewer{1,1}.settings.recon_algo_settings.pixelWidth.val = ...
    ch_data.rawdata_mgr.myImInfo.pixelWidth;
disp('Calulating Precision')
ch_data = rainSTORM_precision(ch_data);

end