function [SupResIm,others] = rainSTORM_reconIP(SupResParams,settings)
% Copyright 2012. Refer to 00_license.txt for details.

linMag = settings.linMag.val;
sizeOfCCDFrame = settings.sizeOfCCDFrame.val;
SupResPosits = [...
    [SupResParams.x_coord]',...
    [SupResParams.y_coord]'...
    ];

nRows = sizeOfCCDFrame(1)*linMag;  % Size of super-resolution reconstruction
nCols = sizeOfCCDFrame(2)*linMag;
SupResIm = uint16(zeros(nRows,nCols)); % 2^16 is unlikely to overflow

myPosits = SupResPosits*linMag; % Scale localisations to super-res grid
myPosits = ceil(myPosits);      % Digitise localisations to super-res grid

% fitPrecision = rainSTORM_precision(SupResParams);
fitPrecision = [[SupResParams.x_std]', [SupResParams.y_std]'];
intensity = double([SupResParams.I]') ./ fitPrecision(:,1);
for lpSRI = 1:size(myPosits,1)
    SupResIm( myPosits(lpSRI,1)  , myPosits(lpSRI,2)  ) = ...
        SupResIm( myPosits(lpSRI,1)  , myPosits(lpSRI,2)  ) + intensity(lpSRI,1);
end % End of allocating dyes to pixels of the reconstruction

others.reconstructionScaleFactor = linMag;
others.sizeOfCCDFrame = sizeOfCCDFrame;
end % End of rainSTORM_recon function, for STORM image reconstruction