function [qualityApprovedlocs, histsDebugPlot] = rainSTORM_loc_filter(SupResParams,filter_settings,flagDebug)

if (flagDebug)
    figure('Name','Debug filters');
end

qualityApprovedlocs = true(size(SupResParams));

filter_settings_names = fieldnames(filter_settings);

for idx_param = 1:length(filter_settings_names);
    param_val_to_eval=[SupResParams.(filter_settings_names{idx_param})];
    if length(filter_settings.(filter_settings_names{idx_param}).val) == 1
        accepted_localizations = filter_settings.(filter_settings_names{idx_param}).val > param_val_to_eval;
    else
        accepted_localizations = ...
            (filter_settings.(filter_settings_names{idx_param}).val(1) <= param_val_to_eval) &...
            (filter_settings.(filter_settings_names{idx_param}).val(2) > param_val_to_eval);
    end
    if (flagDebug)
%        figure('Name',filter_settings_names{idx_param})
%        plot(accepted_localizations)
        subplot(3,5,idx_param);
        hist(accepted_localizations,2)
        title(filter_settings_names{idx_param},'Interpreter','none')
    end
    qualityApprovedlocs = qualityApprovedlocs &...
        ((1-filter_settings.(filter_settings_names{idx_param}).inverted) * accepted_localizations);
end

if (flagDebug)
    histsDebugPlot = getframe(gcf);
    close(gcf);
else
    histsDebugPlot = flagDebug;
end

end


